function setupWebViewJavascriptBridge(callback) {
    //iOS使用
    if (window.WebViewJavascriptBridge) { return callback(WebViewJavascriptBridge); }
    if (window.WVJBCallbacks) { return window.WVJBCallbacks.push(callback); }
    window.WVJBCallbacks = [callback];
    var WVJBIframe = document.createElement('iframe');
    WVJBIframe.style.display = 'none';
    WVJBIframe.src = 'https://__bridge_loaded__';
    document.documentElement.appendChild(WVJBIframe);
    setTimeout(function() { document.documentElement.removeChild(WVJBIframe) }, 0)
    
    //Android使用
    if (window.WebViewJavascriptBridge) {callback(WebViewJavascriptBridge)} else
     {document.addEventListener('WebViewJavascriptBridgeReady', function() {callback(WebViewJavascriptBridge)},false);}
}
//在该function中添加原生调起js方法
setupWebViewJavascriptBridge(function(bridge) {
    
    /* Initialize your app here */
    //注册原生调起方法
    //参数1： buttonjs 注册flag 供原生使用，要和原生统一
    //参数2： data  是原生传给js 的数据
    //参数3： responseCallback 是js 的回调，可以通过该方法给原生传数据
//    bridge.registerHandler('getSystemInfo', function(data, responseCallback) {
//        console.log("JS Echo called with:", data)
//        responseCallback(data)
//    })
//    bridge.callHandler('getDeviceId', '', function responseCallback(responseData) {
//        console.log("JS received response:", responseData)
//    })
})
;(function(window) {
  function loadJSBridge(main) {
    class JSBridge {
      constructor() {
        const self = this;
        return function JSBFn(opts, cb) {
          if (self[this]) {
            self[this](opts, cb);
          }
        }
      }

      /**
       * 获取当前定位
       * @param  {Object}   opts
       *   - [String] bizType 标识当前应用类型，目前值为 'amap'，如无需使用请忽略
       * @param  {Function} cb   回调函数
       * @回调函数参数 {Object}
       *   - [String | null] error 标识异常信息，获取定位成功时应为 null
       *   - [Number] longitude 经度，保留小数点后 6 位
       *   - [Number] latitude 纬度，保留小数点后 6 位
       */
      getCurrentLocation(opts, cb) {
        // @todo
          WebViewJavascriptBridge.callHandler('getCurrentLocation',"",function(response) {
              cb(response);
          });
      }

      /**
       * 开启持续定位
       * @param  {Object}   opts
       *   - {Number} callbackInterval 获取定位的时间间隔
       * @param  {Function} cb 回调函数，开启持续定位后，应定时回调此方法
       * @回调函数参数 {Object}
       *   - [String | null] error 标识异常信息，获取定位成功时应为 null
       *   - [Number] longitude 经度，保留小数点后 6 位
       *   - [Number] latitude 纬度，保留小数点后 6 位
       */
      startContinuousLocation(opts, cb) {
        // @todo
          const { callbackInterval = 5000 } = opts;
          this.continuousLocationTimr = window.setInterval(() => {
              this.getCurrentLocation({}, cb);
          }, callbackInterval);
          
      }

      /**
       * 停止持续定位
       * @param  {Function} cb 回调函数，无需参数
       */
      stopContinuousLocation(cb) {
        // @todo
          clearInterval(this.continuousLocationTimr);
          this.continuousLocationTimr = null;
          
      }
      /**
       * 获取设备号，安卓手机提供IMEI MEID，苹果手机提供IDFA，如果部分机型获取不到一律传空字符串，
       * 不可以是 invalid 等标识字符串
       * @param  {Function} cb 回调函数
       * @回调函数参数 {String} 设备号
       */
      getDeviceId(cb) {
        // @todo
          WebViewJavascriptBridge.callHandler('getDeviceId',"",function(response) {
             console.log(response);
              cb(response);
          });
      }

      /**
       * 设置导航栏标题
       * @param {Object} opts
       *   - {String} title 导航栏标题
       */
      setTitle(opts) {
        // @todo
          document.title = opts['title'];
      }

      /**
       * 复制到剪切板
       * @param {Object} opts
       *   - {String} text 需要复制的文本内容
       */
      setClipboard(param) {
        // @todo
          WebViewJavascriptBridge.callHandler('copyclipboard',param,function(response) {
             
          });
          
      }

      /**
       * 关闭当前 webview
       */
      popWindow() {
        // @todo
          WebViewJavascriptBridge.callHandler('popWindow','',function(response) {
             
          });
          
      }

      /**
       * 打开新的 webview
       * @param  {Object} opts
       *   - {String} url 新页面链接
       *   - {Object} param 参数
       *     - {String} defaultTitle: 新页面标题
       */
      pushWindow(opts) {
        // @todo
          WebViewJavascriptBridge.callHandler('pushWindow',opts,function(response) {
             
          });
          
      }

      /**
       * 获取系统信息
       * @param  {Function} cb 回调函数
       */
      getSystemInfo(cb) {
        // @todo
          WebViewJavascriptBridge.callHandler('getSystemInfo',"",function(response) {
              cb(response);
          });
      }

      /**
       * 禁止手势返回
       * @param {Object} opts
       *   - {Boolean} val 手势返回开启状态 true 为允许返回，false 为禁止返回
       */
      setGestureBack(opts) {
        // @todo
          WebViewJavascriptBridge.callHandler('setGestureBack',opts['val'],function(response) {
             
          });
      }

      /**
       * 隐藏导航栏
       */
      hideTopBar() {
        // @todo
          WebViewJavascriptBridge.callHandler('hideTopBar','',function(response) {
             
          });
      }

      /**
       * 调起支付收银台
       * @param  {Object}   opts
       *   - {String} orderStr 支付宝支付交易字符串
       * @param  {Function} cb 回调函数
       * @回调函数参数 {Object}
       *   - {Number|String} resultCode 支付宝返回的 code
       *   - {String} memo   错误描述
       */
      tradePay(opts, cb) {
        // @todo
          WebViewJavascriptBridge.callHandler('alipay',opts['orderStr'],function(response) {
             cb(response);
          });
      }
    }

    window.JSBridge = new JSBridge();
    main();
  }

  window.loadJSBridge = loadJSBridge;
  loadJSBridge(() => {
    console.log('loadJSBridge success');
  });
})(window);

